<template>
    <div class="browse spacing-top-mobile">
        <v-row class="pl-md-16 pr-md-16 pr-lg-0 pb-md-16 browse-section">
            <!-- PRODUCTS SECTION -->
            <v-col lg="9" md="12">
                <v-row class="pt-md-16 mt-md-16">
                    <v-col cols="12">
                        <v-stepper v-model="e1" alt-labels color="red" flat>
                            <v-stepper-header>
                                <v-stepper-step color="red" step="1"
                                    ><h2 class="font-syne-bold">
                                        {{ $t('box.shipping') }}
                                    </h2></v-stepper-step
                                >

                                <v-divider></v-divider>

                                <v-stepper-step color="red" step="2"
                                    ><h2 class="font-syne-bold">
                                        {{ $t('box.payment') }}
                                    </h2>
                                </v-stepper-step>

                                <v-divider></v-divider>

                                <v-stepper-step color="red" step="3"
                                    ><h2 class="font-syne-bold">
                                        {{ $t('box.confirmation') }}
                                    </h2></v-stepper-step
                                >
                            </v-stepper-header>

                            <v-stepper-items>
                                <v-stepper-content step="1">
                                    <v-row>
                                        <v-col cols="12">
                                            <p
                                                class="
                                                    font-metropolis-regular
                                                    mb-0
                                                "
                                            >
                                                {{
                                                    $t(
                                                        'form.deliveryAddress.text'
                                                    )
                                                }}
                                            </p>
                                        </v-col>
                                        <v-col cols="12">
                                            <v-radio-group
                                                v-if="addresses.length > 0"
                                                v-model="addressGroup"
                                                row
                                            >
                                                <v-radio
                                                    v-for="(
                                                        address, a
                                                    ) in addresses"
                                                    :key="'address-' + a"
                                                    :value="address.id"
                                                    color="white"
                                                    off-icon="mdi-checkbox-blank-circle-outline"
                                                    on-icon="mdi-checkbox-marked-circle-outline"
                                                    :rules="[requiredRules]"
                                                    @click="selectAddress"
                                                >
                                                    <template v-slot:label>
                                                        <v-row>
                                                            <v-col cols="12">
                                                                <p
                                                                    class="
                                                                        font-metropolis-regular
                                                                        mb-0
                                                                    "
                                                                >
                                                                    {{
                                                                        address.firstName
                                                                    }}
                                                                    {{
                                                                        address.lastName
                                                                    }}
                                                                </p>
                                                                <p
                                                                    class="
                                                                        font-metropolis-regular
                                                                        font-12
                                                                        text-grey
                                                                        mb-0
                                                                    "
                                                                >
                                                                    {{
                                                                        address.address1
                                                                    }},
                                                                </p>
                                                                <p
                                                                    class="
                                                                        font-metropolis-regular
                                                                        font-12
                                                                        text-grey
                                                                        mb-0
                                                                    "
                                                                >
                                                                    {{
                                                                        address.address2
                                                                            ? address.address2 +
                                                                              ', ' +
                                                                              address.city
                                                                            : address.city
                                                                    }},
                                                                </p>
                                                                <p
                                                                    class="
                                                                        font-metropolis-regular
                                                                        font-12
                                                                        text-grey
                                                                        mb-0
                                                                    "
                                                                >
                                                                    {{
                                                                        address.postcode
                                                                    }},
                                                                    {{
                                                                        address.state
                                                                    }},
                                                                </p>
                                                                <p
                                                                    class="
                                                                        font-metropolis-regular
                                                                        font-12
                                                                        text-grey
                                                                        mb-0
                                                                    "
                                                                >
                                                                    {{
                                                                        address.country
                                                                    }}
                                                                </p></v-col
                                                            ></v-row
                                                        >
                                                    </template>
                                                </v-radio>
                                            </v-radio-group>
                                            <v-row v-else>
                                                <v-col>
                                                    <p class="highlight-text">
                                                        {{
                                                            $t(
                                                                'common.noAddress'
                                                            )
                                                        }}
                                                    </p>
                                                </v-col>
                                            </v-row>
                                        </v-col>
                                        <v-col cols="12">
                                            <v-btn
                                                class="
                                                    mt-5
                                                    lowercase
                                                    br-0
                                                    font-syne-bold
                                                    border-white
                                                    transparent-bg
                                                "
                                                @click="addNewAddress"
                                                ><v-icon left> mdi-plus </v-icon
                                                >{{
                                                    $t(
                                                        'buttons.useDifferentAddressBtn'
                                                    )
                                                }}</v-btn
                                            >
                                        </v-col>
                                        <v-col v-show="!panel" cols="12">
                                            <v-form
                                                v-show="pageLoaded"
                                                ref="addressForm"
                                                lazy-validation
                                                @submit.prevent
                                            >
                                                <v-row
                                                    :class="[
                                                        {
                                                            'pl-0 pr-0':
                                                                $vuetify
                                                                    .breakpoint
                                                                    .smAndDown,
                                                        },
                                                    ]"
                                                >
                                                    <v-col cols="12">
                                                        <!-- ADD ADDRESS FORM -->
                                                        <v-row>
                                                            <v-col
                                                                cols="6"
                                                                class="
                                                                    form-field
                                                                "
                                                                ><!-- FIRST NAME -->
                                                                <v-text-field
                                                                    ref="name"
                                                                    v-model="
                                                                        form
                                                                            .firstName
                                                                            .value
                                                                    "
                                                                    :label="
                                                                        $t(
                                                                            'form.firstName.text'
                                                                        )
                                                                    "
                                                                    :placeholder="
                                                                        $t(
                                                                            'form.firstName.placeholder'
                                                                        )
                                                                    "
                                                                    solo
                                                                    required
                                                                    :rules="[
                                                                        requiredRules,
                                                                    ]"
                                                                ></v-text-field
                                                            ></v-col>
                                                            <v-col
                                                                cols="6"
                                                                class="
                                                                    form-field
                                                                "
                                                                ><!-- LAST NAME -->
                                                                <v-text-field
                                                                    ref="name"
                                                                    v-model="
                                                                        form
                                                                            .lastName
                                                                            .value
                                                                    "
                                                                    :label="
                                                                        $t(
                                                                            'form.lastName.text'
                                                                        )
                                                                    "
                                                                    :placeholder="
                                                                        $t(
                                                                            'form.lastName.placeholder'
                                                                        )
                                                                    "
                                                                    solo
                                                                    required
                                                                    :rules="[
                                                                        requiredRules,
                                                                    ]"
                                                                ></v-text-field
                                                            ></v-col>
                                                        </v-row>
                                                        <v-row>
                                                            <v-col
                                                                cols="6"
                                                                class="
                                                                    form-field
                                                                "
                                                                ><!-- MOBILE -->
                                                                <v-text-field
                                                                    ref="mobile"
                                                                    v-model="
                                                                        form
                                                                            .mobile
                                                                            .value
                                                                    "
                                                                    :label="
                                                                        $t(
                                                                            'form.mobile.text'
                                                                        )
                                                                    "
                                                                    :placeholder="
                                                                        $t(
                                                                            'form.mobile.placeholder'
                                                                        )
                                                                    "
                                                                    solo
                                                                    required
                                                                    :rules="[
                                                                        requiredRules,
                                                                    ]"
                                                                ></v-text-field
                                                            ></v-col>
                                                            <v-col
                                                                cols="6"
                                                                class="
                                                                    form-field
                                                                "
                                                                ><!-- COMPANY -->
                                                                <v-text-field
                                                                    ref="company"
                                                                    v-model="
                                                                        form
                                                                            .company
                                                                            .value
                                                                    "
                                                                    :label="
                                                                        $t(
                                                                            'form.company.text'
                                                                        )
                                                                    "
                                                                    :placeholder="
                                                                        $t(
                                                                            'form.company.placeholder'
                                                                        )
                                                                    "
                                                                    solo
                                                                ></v-text-field
                                                            ></v-col>
                                                        </v-row>
                                                        <v-row>
                                                            <v-col
                                                                cols="12"
                                                                class="
                                                                    form-field
                                                                "
                                                                ><!-- ADDRESS 1 -->
                                                                <v-text-field
                                                                    ref="address1"
                                                                    v-model="
                                                                        form
                                                                            .address1
                                                                            .value
                                                                    "
                                                                    :label="
                                                                        $t(
                                                                            'form.address1.text'
                                                                        )
                                                                    "
                                                                    :placeholder="
                                                                        $t(
                                                                            'form.address1.placeholder'
                                                                        )
                                                                    "
                                                                    solo
                                                                    :rules="[
                                                                        requiredRules,
                                                                    ]"
                                                                ></v-text-field
                                                            ></v-col>
                                                        </v-row>
                                                        <v-row>
                                                            <v-col
                                                                cols="12"
                                                                class="
                                                                    form-field
                                                                "
                                                                ><!-- ADDRESS 2 -->
                                                                <v-text-field
                                                                    ref="address2"
                                                                    v-model="
                                                                        form
                                                                            .address2
                                                                            .value
                                                                    "
                                                                    :label="
                                                                        $t(
                                                                            'form.address2.text'
                                                                        )
                                                                    "
                                                                    :placeholder="
                                                                        $t(
                                                                            'form.address2.placeholder'
                                                                        )
                                                                    "
                                                                    solo
                                                                ></v-text-field
                                                            ></v-col>
                                                        </v-row>
                                                        <v-row>
                                                            <v-col
                                                                cols="6"
                                                                class="
                                                                    form-field
                                                                "
                                                                ><!-- CITY -->
                                                                <v-text-field
                                                                    ref="city"
                                                                    v-model="
                                                                        form
                                                                            .city
                                                                            .value
                                                                    "
                                                                    :label="
                                                                        $t(
                                                                            'form.city.text'
                                                                        )
                                                                    "
                                                                    :placeholder="
                                                                        $t(
                                                                            'form.city.placeholder'
                                                                        )
                                                                    "
                                                                    solo
                                                                    :rules="[
                                                                        requiredRules,
                                                                    ]"
                                                                ></v-text-field
                                                            ></v-col>
                                                            <v-col
                                                                cols="6"
                                                                class="
                                                                    form-field
                                                                "
                                                                ><!-- STATE -->
                                                                <v-text-field
                                                                    ref="state"
                                                                    v-model="
                                                                        form
                                                                            .state
                                                                            .value
                                                                    "
                                                                    :label="
                                                                        $t(
                                                                            'form.state.text'
                                                                        )
                                                                    "
                                                                    :placeholder="
                                                                        $t(
                                                                            'form.state.placeholder'
                                                                        )
                                                                    "
                                                                    solo
                                                                    :rules="[
                                                                        requiredRules,
                                                                    ]"
                                                                ></v-text-field
                                                            ></v-col>
                                                        </v-row>
                                                        <v-row>
                                                            <v-col
                                                                cols="6"
                                                                class="
                                                                    form-field
                                                                "
                                                                ><!-- POSTCODE -->
                                                                <v-text-field
                                                                    ref="postcode"
                                                                    v-model="
                                                                        form
                                                                            .postcode
                                                                            .value
                                                                    "
                                                                    :label="
                                                                        $t(
                                                                            'form.postcode.text'
                                                                        )
                                                                    "
                                                                    :placeholder="
                                                                        $t(
                                                                            'form.postcode.placeholder'
                                                                        )
                                                                    "
                                                                    solo
                                                                    :rules="[
                                                                        requiredRules,
                                                                    ]"
                                                                ></v-text-field
                                                            ></v-col>
                                                            <v-col
                                                                cols="6"
                                                                class="
                                                                    form-field
                                                                "
                                                                ><!-- COUNTRY -->
                                                                <v-select
                                                                    ref="country"
                                                                    v-model="
                                                                        form
                                                                            .country
                                                                            .value
                                                                    "
                                                                    :label="
                                                                        $t(
                                                                            'form.country.text'
                                                                        )
                                                                    "
                                                                    :items="
                                                                        countryList
                                                                    "
                                                                    solo
                                                                    required
                                                                    :rules="[
                                                                        requiredRules,
                                                                    ]"
                                                                ></v-select
                                                            ></v-col>
                                                        </v-row>
                                                        <!-- SUBMIT BUTTON -->
                                                        <v-row>
                                                            <v-col>
                                                                <v-btn
                                                                    :block="
                                                                        $vuetify
                                                                            .breakpoint
                                                                            .smAndDown
                                                                    "
                                                                    class="
                                                                        lowercase
                                                                        br-0
                                                                        pl-10
                                                                        pr-10
                                                                        font-syne-bold
                                                                    "
                                                                    color="badge"
                                                                    :disabled="
                                                                        isAddAddressBtnDisabled
                                                                    "
                                                                    :loading="
                                                                        isAddAddressLoaderBtnDisabled
                                                                    "
                                                                    @click="
                                                                        validateAddressForm
                                                                    "
                                                                    >{{
                                                                        $t(
                                                                            'buttons.useThisAddressBtn'
                                                                        )
                                                                    }}</v-btn
                                                                >
                                                            </v-col>
                                                        </v-row>
                                                    </v-col>
                                                </v-row>
                                            </v-form>
                                        </v-col>
                                    </v-row>
                                </v-stepper-content>

                                <v-stepper-content step="2">
                                    <v-form
                                        ref="paymentForm"
                                        lazy-validation
                                        @submit.prevent
                                    >
                                        <v-row>
                                            <v-col>
                                                <h2 class="font-syne-bold">
                                                    {{ $t('box.payment') }}
                                                </h2>
                                            </v-col>
                                        </v-row>
                                        <v-row>
                                            <v-col cols="12" md="8">
                                                <div
                                                    id="card-wrapper"
                                                    class="subscription"
                                                >
                                                    <div id="card-element">
                                                        <!-- A Stripe Element will be inserted here. -->
                                                    </div>

                                                    <!-- Used to display form errors. -->
                                                    <div
                                                        id="card-errors"
                                                        role="alert"
                                                    />
                                                </div>
                                            </v-col>
                                        </v-row>
                                    </v-form>
                                </v-stepper-content>

                                <v-stepper-content step="3">
                                    <v-row>
                                        <v-col class="d-flex justify-center">
                                            <v-icon
                                                large
                                                class="font-100"
                                                color="green darken-2"
                                            >
                                                mdi-check-circle
                                            </v-icon>
                                        </v-col>
                                    </v-row>
                                    <v-row>
                                        <v-col
                                            class="
                                                d-flex
                                                justify-center
                                                font-metropolis-regular
                                            "
                                        >
                                            {{ $t('cart.success') }}
                                        </v-col>
                                    </v-row>
                                    <v-row>
                                        <v-col
                                            class="
                                                d-flex
                                                justify-center
                                                font-syne-bold
                                            "
                                        >
                                            {{ $t('cart.thanks') }}
                                        </v-col>
                                    </v-row>
                                    <v-row>
                                        <v-col class="d-flex justify-center">
                                            <v-img
                                                :src="logo"
                                                max-height="20"
                                                max-width="100"
                                            />
                                        </v-col>
                                    </v-row>
                                    <v-row>
                                        <v-col class="d-flex justify-center">
                                            <v-btn @click="goHomePage">
                                                {{ $t('buttons.backHome') }}
                                            </v-btn>
                                        </v-col>
                                    </v-row>
                                </v-stepper-content>
                            </v-stepper-items>
                        </v-stepper>
                    </v-col>
                </v-row>
            </v-col>

            <!-- BOX BAR -->
            <v-col md="3" class="black-bg">
                <v-row class="drag-height mt-16">
                    <v-col>
                        <v-row class="drag-height-row">
                            <v-col
                                v-if="cartShopItems.length === 0"
                                cols="12"
                                class="d-flex justify-center mt-16"
                            >
                                <v-img
                                    :src="cart"
                                    max-width="98"
                                    max-height="98"
                                />
                            </v-col>
                            <v-col cols="12" class="justify-center">
                                <p
                                    v-if="cartShopItems.length === 0"
                                    class="box-title-text text-center"
                                >
                                    {{ $t('common.addToSideCart') }}
                                </p>
                                <div v-else-if="cartShopItems.length > 0">
                                    <!-- SUBSCRIBED PLAN -->
                                    <v-row>
                                        <v-col md="10" cols="10" offset="1">
                                            <v-col class="pl-0">
                                                <h3 class="font-syne-bold">
                                                    {{
                                                        $t(
                                                            'common.orderSummary'
                                                        )
                                                    }}
                                                </h3>
                                            </v-col>
                                            <v-divider />
                                        </v-col>
                                    </v-row>
                                    <v-row
                                        v-for="(i, items) of cartShopItems"
                                        :key="'cart-' + items"
                                    >
                                        <v-col cols="3" offset="1">
                                            <v-img
                                                v-if="i.image"
                                                :src="i.image.url"
                                            />
                                        </v-col>
                                        <v-col
                                            cols="7"
                                            class="
                                                align-content-space-between
                                                flex-wrap
                                            "
                                        >
                                            <v-row>
                                                <v-col>
                                                    <p
                                                        class="
                                                            product-title-text
                                                            mb-1
                                                        "
                                                    >
                                                        {{ i.brand.name }}
                                                        {{ i.name }}
                                                    </p>
                                                    <p
                                                        class="
                                                            product-desc-text
                                                            mb-1
                                                        "
                                                    >
                                                        {{ i.option.name }}
                                                    </p>
                                                </v-col>
                                            </v-row>

                                            <v-row>
                                                <v-col
                                                    cols="align-end justify-start d-flex"
                                                >
                                                    <p
                                                        class="
                                                            product-title-text
                                                            mb-1
                                                            d-flex
                                                            justify-end
                                                            align-end
                                                        "
                                                    >
                                                        x {{ i.quantity }}
                                                    </p>
                                                </v-col>
                                                <v-col
                                                    cols="7"
                                                    class="
                                                        align-end
                                                        justify-end
                                                        d-flex
                                                    "
                                                >
                                                    <p
                                                        class="
                                                            product-title-text
                                                            mb-1
                                                            d-flex
                                                            justify-end
                                                            align-end
                                                        "
                                                    >
                                                        {{ currencyName }}
                                                        {{
                                                            i.price[currency]
                                                                .price
                                                        }}
                                                    </p>
                                                </v-col>
                                            </v-row>
                                        </v-col>
                                    </v-row>

                                    <v-row>
                                        <v-col cols="10" offset="1">
                                            <v-divider />
                                        </v-col>
                                    </v-row>
                                    <!-- TOTAL AMOUNT -->
                                    <v-row>
                                        <v-col md="10" cols="10" offset="1">
                                            <!-- PROMO CODE -->
                                            <!-- <v-row v-if="e1 == 2">
                                                    <v-col
                                                        cols="12"
                                                        class="
                                                            subscription
                                                            d-flex
                                                            align-center
                                                            justify-end
                                                        "
                                                    >
                                                        <v-text-field
                                                            v-model="promo"
                                                            hide-details="auto"
                                                            dense
                                                            filled
                                                            solo
                                                            color="badge"
                                                            class="
                                                                white-bg
                                                                text-grey
                                                                font-metropolis-regular
                                                            "
                                                            :label="
                                                                $t(
                                                                    'cart.promoCode'
                                                                )
                                                            "
                                                            type="text"
                                                            :loading="promoLoad"
                                                            :disabled="
                                                                promoDisabled
                                                            "
                                                        ></v-text-field>
                                                        <v-btn
                                                            class="redeemBtn"
                                                            text
                                                            color="black"
                                                            :loading="promoLoad"
                                                            :disabled="
                                                                promoDisabled
                                                            "
                                                            @click="
                                                                redeemPromoCode
                                                            "
                                                        >
                                                            {{
                                                                $t(
                                                                    'buttons.redeemBtn'
                                                                )
                                                            }}
                                                        </v-btn>
                                                    </v-col>
                                                </v-row> -->
                                            <!-- SUBTOTAL -->
                                            <v-row>
                                                <v-col
                                                    cols="5"
                                                    class="pt-5 pb-0"
                                                >
                                                    <p
                                                        class="
                                                            cart-text
                                                            text-white
                                                            mb-0
                                                        "
                                                    >
                                                        {{
                                                            $t('cart.subtotal')
                                                        }}
                                                    </p>
                                                </v-col>
                                                <v-col
                                                    class="text-right pt-5 pb-0"
                                                >
                                                    <p class="text-white mb-0">
                                                        {{ currencyName }}
                                                        {{ getTotalCartPrice }}
                                                    </p>
                                                </v-col>
                                            </v-row>

                                            <!-- SHIPPING -->
                                            <v-row>
                                                <v-col cols="12">
                                                    <v-row>
                                                        <v-col
                                                            cols="5"
                                                            class="pt-5 pb-0"
                                                        >
                                                            <p
                                                                class="
                                                                    cart-text
                                                                    text-white
                                                                    mb-0
                                                                "
                                                            >
                                                                {{
                                                                    $t(
                                                                        'cart.shippingFee'
                                                                    )
                                                                }}
                                                            </p>
                                                        </v-col>
                                                        <v-col
                                                            class="
                                                                text-right
                                                                pt-5
                                                                pb-0
                                                            "
                                                        >
                                                            <p
                                                                class="
                                                                    text-white
                                                                    mb-0
                                                                "
                                                            >
                                                                {{
                                                                    currencyName
                                                                }}
                                                                0
                                                            </p>
                                                        </v-col>
                                                    </v-row>
                                                    <v-divider class="mt-10" />
                                                </v-col>
                                            </v-row>

                                            <!-- TOTAL VALUE -->
                                            <v-row>
                                                <v-col
                                                    cols="5"
                                                    class="pt-5 pb-0"
                                                >
                                                    <p
                                                        class="
                                                            cart-text
                                                            text-white
                                                            mb-0
                                                        "
                                                    >
                                                        {{ $t('cart.total') }}
                                                    </p>
                                                </v-col>
                                                <v-col
                                                    class="text-right pt-3 pb-0"
                                                >
                                                    <h2 class="text-white mb-0">
                                                        {{ currencyName }}
                                                        {{ getTotalCartPrice }}
                                                    </h2>
                                                </v-col>
                                            </v-row>

                                            <!-- CHECKOUT BUTTON -->
                                            <v-row class="pt-10">
                                                <v-col>
                                                    <v-btn
                                                        v-if="e1 == 1"
                                                        class="
                                                            lowercase
                                                            br-0
                                                            pl-10
                                                            pr-10
                                                            font-syne-bold
                                                        "
                                                        color="badge"
                                                        block
                                                        large
                                                        :loading="
                                                            isButtonDisabled
                                                        "
                                                        :disabled="
                                                            isButtonDisabled
                                                        "
                                                        @click="goPayment"
                                                        >{{
                                                            $t(
                                                                'buttons.confirmShippingBtn'
                                                            )
                                                        }}</v-btn
                                                    >
                                                    <v-btn
                                                        v-if="e1 == 2"
                                                        class="
                                                            lowercase
                                                            br-0
                                                            mb-2
                                                            pl-10
                                                            pr-10
                                                            font-syne-bold
                                                        "
                                                        block
                                                        large
                                                        :loading="
                                                            isButtonDisabled
                                                        "
                                                        :disabled="
                                                            isButtonDisabled
                                                        "
                                                        @click="e1 = 1"
                                                        >{{
                                                            $t(
                                                                'buttons.backToShippingBtn'
                                                            )
                                                        }}</v-btn
                                                    >
                                                    <v-btn
                                                        v-if="e1 == 2"
                                                        class="
                                                            lowercase
                                                            br-0
                                                            pl-10
                                                            pr-10
                                                            font-syne-bold
                                                        "
                                                        color="badge"
                                                        block
                                                        large
                                                        :loading="
                                                            isButtonDisabled
                                                        "
                                                        :disabled="
                                                            isButtonDisabled
                                                        "
                                                        @click="makePayment"
                                                        >{{
                                                            $t('buttons.payBtn')
                                                        }}</v-btn
                                                    >
                                                </v-col>
                                            </v-row>
                                        </v-col>
                                    </v-row>
                                </div>
                            </v-col>
                        </v-row>
                    </v-col>
                </v-row>
            </v-col>
        </v-row>
    </div>
</template>

<script lang="ts">
import { Vue, Component } from 'nuxt-property-decorator'
import { mapGetters } from 'vuex'
import VuetifyNumberInput from '@jzolago/vuetify-number-input'

Vue.use(VuetifyNumberInput)

@Component({
    head() {
        return {
            title: 'Shop Checkout',
        }
    },

    computed: {
        ...mapGetters({
            currency: 'currency/getCurrency',
            currencyName: 'currency/getCurrencyName',
            cartShopItems: 'cart/getCartShopItems',
            cartShopPrice: 'cart/getCartShopPrice',
            addresses: 'user/getAddresses',
            selectedShippingAddress: 'user/getSelectedShippingAddress',
        }),
    },
})
export default class Browse extends Vue {
    // Data
    qty: Number = 0
    e1: Number = 1
    addressGroup: number = 0
    panel: number = 1
    selectedShippingAddress!: Function
    shippingAddress!: any
    newShippingAddress: boolean = false
    isAddAddressBtnDisabled: boolean = false
    isAddAddressLoaderBtnDisabled: boolean = false
    $refs!: {
        returnBoxForm: HTMLFormElement
        addressForm: HTMLFormElement
        paymentForm: HTMLFormElement
    }

    currencyName!: string
    ref: any = this.$refs
    cartShopPrice!: Function
    pageLoaded: boolean = false
    cart: String = require('~/assets/images/cartbig.png')
    dataLoad: Boolean = true
    dataLoading: Boolean = true
    isButtonDisabled: Boolean = false
    totalProduct: Number = 0

    form: { [key: string]: any } = {
        firstName: {
            value: '',
            error: null,
            requestKey: 'first_name',
        },
        lastName: {
            value: '',
            error: null,
            requestKey: 'last_name',
        },
        mobile: {
            value: '',
            error: null,
            requestKey: 'mobile',
        },
        company: {
            value: '',
            error: null,
            requestKey: 'company',
        },
        address1: {
            value: '',
            error: null,
            requestKey: 'address_1',
        },
        address2: {
            value: '',
            error: null,
            requestKey: 'address_2',
        },
        city: {
            value: '',
            error: null,
            requestKey: 'city',
        },
        state: {
            value: '',
            error: null,
            requestKey: 'state',
        },
        country: {
            value: '',
            error: null,
            requestKey: 'country',
        },
        postcode: {
            value: '',
            error: null,
            requestKey: 'postcode',
        },
        deliveryTime: {
            value: '',
            error: null,
            requestKey: 'delivery_time',
        },
    }

    countryList: any = ['Malaysia']
    sortList: any = [
        {
            id: 'price&false',
            name: 'Price: Low to High',
        }, // 0 = asc product price
        {
            id: 'price&true',
            name: 'Price: High to Low',
        }, // 1 = desc product price
        /*         {
            id: 'created_at&true',
            name: 'Newest',
        }, // 2 = desc product created */
        {
            id: 'created_at&false',
            name: 'Oldest',
        }, // 3 = asc product created
        {
            id: 'new_arrival&true',
            name: 'New Arrivals',
        }, // 4 = new arrivals
        {
            id: 'most_popular&true',
            name: 'Most Popular',
        }, // 5 = most popular
        /*  {
            id: 'most_popular&false',
            name: 'Least Popular',
        }, // 6 = least popular,
        {
            id: 'name&false',
            name: 'Product Name',
        }, // 7 = asc product name */
    ]

    currency!: number
    formHasErrors: Boolean = true
    stripe: any = ''
    elements: any = ''
    logo: String = require('~/assets/images/logo.svg')

    // Methods
    goHomePage() {
        this.$router.push({ path: '/' })
    }

    validateAddressForm() {
        if (typeof this.$refs === 'undefined') {
            return
        }

        setTimeout(() => {
            const valid = this.$refs.addressForm.validate()

            if (valid) {
                this.newShippingAddress = true
                this.isAddAddressBtnDisabled = true
                this.addressGroup = 0
            }
        }, 300)
    }

    addNewAddress() {
        if (this.panel === 1) {
            this.panel = 0
        } else {
            this.panel = 1
        }
    }

    selectAddress() {
        this.newShippingAddress = false
        this.isAddAddressBtnDisabled = false
    }

    get getTotalCartPrice() {
        return this.cartShopPrice(this.currency)
    }

    requiredRules(v: string) {
        if (v) {
            return true
        } else {
            return this.$t('form.validation.required')
        }
    }

    validateForm() {
        const valid = this.$refs.addressForm.validate()
        if (this.addressGroup === 0 && !valid) {
            const val = {
                text: this.$t('notification.address.select'),
                color: 'white',
                icon: 'mdi-alert',
            }
            this.$store.dispatch('snackbar/displaySnackBar', val)
        } else if (this.newShippingAddress) {
            this.shippingAddress = {
                first_name: this.form.firstName.value,
                last_name: this.form.lastName.value,
                mobile: this.form.mobile.value,
                company: this.form.company.value,
                address_1: this.form.address1.value,
                address_2: this.form.address2.value,
                city: this.form.city.value,
                state: this.form.state.value,
                country: this.form.country.value,
                postcode: this.form.postcode.value,
            }
            this.e1 = 2
        } else {
            const selectedAddress = this.selectedShippingAddress(
                this.addressGroup
            )
            this.shippingAddress = {
                first_name: selectedAddress.firstName,
                last_name: selectedAddress.lastName,
                mobile: selectedAddress.mobile,
                company: selectedAddress.company,
                address_1: selectedAddress.address1,
                address_2: selectedAddress.address2,
                city: selectedAddress.city,
                state: selectedAddress.state,
                country: selectedAddress.country,
                postcode: selectedAddress.postcode,
            }
            this.e1 = 2
        }
    }

    goPayment() {
        this.validateForm()
    }

    makePayment() {
        if (typeof this.$refs === 'undefined') {
            return
        }

        setTimeout(() => {
            const valid = this.$refs.paymentForm.validate()

            if (valid) {
                this.submit()
            }
        }, 300)
    }

    submit() {
        this.isButtonDisabled = true

        // Initiate payment
        this.stripe
            .createPaymentMethod({
                type: 'card',
                card: this.elements.getElement('card'),
            })
            .then((result: any) => {
                if (result.error) {
                    this.isButtonDisabled = false
                }

                if (result.paymentMethod) {
                    // proceed payment
                    this.submitPayment(result.paymentMethod)
                }
            })
    }

    submitPayment(payment: any) {
        // Call checkout API
        this.$api.checkout
            .checkoutShop(
                this.shippingAddress,
                this.currencyName.toLowerCase(),
                payment
            )
            .then(() => {
                const val = {
                    text: this.$t('notification.checkout.success'),
                    color: 'green',
                    icon: 'mdi-check',
                }
                this.$store.dispatch('snackbar/displaySnackBar', val)

                // Clear cart
                this.$store.commit('cart/clearCartShop')

                // Reopen button
                this.isButtonDisabled = false

                this.e1 = 3
            })
            .catch((error) => {
                this.isButtonDisabled = false
                // Get errors object
                if (error.response?.status === 400) {
                    const val = {
                        text: error.response.data.message,
                        color: 'white',
                        icon: 'mdi-alert',
                    }
                    this.$store.dispatch('snackbar/displaySnackBar', val)
                }
            })
    }

    mounted() {
        if (typeof this.$refs !== 'undefined') {
            this.ref = this.$refs
            this.pageLoaded = true
        }

        // Stripe
        const style = {
            base: {
                color: '#32325d',
                fontFamily: '"Helvetica Neue", Helvetica, sans-serif',
                fontSmoothing: 'antialiased',
                fontSize: '14px',
                '::placeholder': {
                    color: '#aab7c4',
                },
            },
            invalid: {
                color: '#ff0000',
                iconColor: '#ff0000',
            },
        }

        this.elements = this.stripe.elements()
        // Create an instance of the card Element.
        const card = this.elements.create('card', {
            style,
            hidePostalCode: true,
        })

        // Add an instance of the card Element into the `card-element` <div>.
        if (document.getElementById('card-element')) {
            card.mount('#card-element')
        }
        // Handle real-time validation errors from the card Element.
        card.on('change', (event: any) => {
            const displayError = document.getElementById('card-errors')
            if (event.error) {
                this.formHasErrors = true
                this.isButtonDisabled = true
                displayError!.textContent = event.error.message
            } else {
                this.isButtonDisabled = false
                this.formHasErrors = false
                displayError!.textContent = ''
            }
        })
    }

    created() {
        this.stripe = this.$stripe
    }
}
</script>
